{\rtf0\ansi{\fonttbl\f1\fmodern Courier;\f4\ftech Symbol;\f3\fmodern Ohlfs;}
\margl40
\margr40
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f1\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 eText.PlainText.h \

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Interface for the PlainText markup formats of eText (ASCII, C)
\b0 \
//	
\b\i CATEGORY
\b0 :
\i0 	
\b PlainText
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b <ASCIISupport>
\b0 , 
\b <CSupport>
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b None
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f4\i0 
\f1\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Description
\b0\i0 \
//		These methods deal with ASCII and C output. They also declare a\
//	printf proc (%y) that uses NXToAscii to clean up the upper 128.\
//\
//	
\b\i History
\b0\i0 \
//	11/20/94:	
\b Extended to support writing ranges.
\b0 \
//	10/17/94:	
\b Cleaned up for eText5.
\b0 \
//	08/05/94:	
\b Completely Rearchitected for 5.0. RK
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import "
\b eText.Class.h
\b0 "\
\
//\
//	
\b Encoder API
\b0 \
//\
	extern void 
\b ASCIIEncoder
\b0 (NXStream *
\b stream
\b0 , unsigned char *
\b item
\b0 , int 
\b len
\b0 );\
\

\i @interface eText(PlainText)\

\i0 //\
//	
\b Path Operators\

\b0 //\
	- 
\b readASCIIfromPath
\b0 :(const char *)path;\
	- 
\b writeASCIItoPath
\b0 :(const char *)path;\
\
	- 
\b readCfromPath
\b0 :(const char *)path;\
	- 
\b writeCtoPath
\b0 :(const char *)path;\
\
//\
//	
\b Stream Operators
\b0 \
//\
	- 
\b readASCII
\b0 : (
\b NXStream
\b0  *)s;\
	- 
\b writeASCII
\b0 : (
\b NXStream
\b0  *)s;\
	- 
\b writeASCII
\b0 : (
\b NXStream
\b0  *)s 
\b from
\b0 :(
\b int
\b0 ) start 
\b to
\b0 :(
\b int
\b0 ) end;\
	\
	- 
\b readC
\b0 : (
\b NXStream
\b0  *)s;\
	- 
\b writeC
\b0 : (
\b NXStream
\b0  *)s;\
	- 
\b writeC
\b0 : (
\b NXStream
\b0  *)s 
\b from
\b0 :(
\b int
\b0 ) start 
\b to
\b0 :(
\b int
\b0 ) end;\
	\
@end
}
